#if !defined(FPP_H)
#define FPP_H

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "xstdlib.h"

#ifndef EXTERN
#define EXTERN extern
#endif

#if STDC
#define ERR_PREFIX		"\?\? "	/* not a trigraph! */
#else
#define ERR_PREFIX		"?? "
#endif

#if defined(FFLUSH)
#undef FFLUSH
#endif
#define FFLUSH			(void)fflush

#if defined(FPRINTF)
#undef FPRINTF
#endif
#define FPRINTF			(void)fprintf

#define MAXLEVEL		25	/* maximum conditional nesting */
#define MAXLINE			255	/* maximum input line length */
#define MSG_PREFIX		"!! "
#define NOOP
#define OUT_PREFIX		"C-fpp-"
#define PERMANENT(s)		((s[0] == '_') && (s[1] == '_'))

#if defined(PRINTF)
#undef PRINTF
#endif
#define PRINTF			(void)printf

#if defined(SPRINTF)
#undef SPRINTF
#endif
#define SPRINTF			(void)sprintf

#define STDIN			"--"
#define VERSION			"fpp -- C version 2.0.0 [10-Dec-1993]"

#define initial(c)		(fpp_line[0] == (c))
#define is_comment()	( initial('C') || initial('c') || initial('*') )
#define is_id_line()	(is_comment() && (strncmp(&fpp_line[1],"-fpp-",5) == 0))
#define is_token_start(c)	(isalpha(c) || ((c) == '_'))
#define is_token_letter(c)	(isalnum(c) || ((c) == '_'))
#define print_line(p)		(void)puts(p)
#define skip_whitespace(p)	while(isspace(*p)) ++p
#define stddbg			stderr

#ifndef EXIT_FAILURE
#define EXIT_FAILURE 1
#endif

#ifndef EXIT_SUCCESS
#define EXIT_SUCCESS 0
#endif

EXTERN int branch_done[MAXLEVEL];	/* for conditional branch records */
EXTERN char err_line[MAXLINE+1];	/* error message buffer */
EXTERN char expression[2*MAXLINE+1];	/* for expression expansion */
EXTERN char *ee[MAXLINE+1];		/* pointers into expression[] */
EXTERN int FNR;				/* record number in current file */
EXTERN int fpp_code;			/* exit code */
EXTERN int fpp_debug;			/* non-zero if debugging */
EXTERN FILE *fpp_infile;		/* pointer to current input file */
EXTERN char fpp_line[MAXLINE+1];	/* current input line */
EXTERN const char *fpp_name;		/* current input file name */
EXTERN char fpp_number[18];		/* current input line number */
EXTERN int level;			/* conditional nesting level */
EXTERN int ke;				/* current expression fields */
EXTERN int lineno[MAXLEVEL];		/* for conditional branch records */
EXTERN int ne;				/* number of expression fields */
EXTERN int NR;				/* record number in input */
EXTERN int RSTART;			/* regexp match begin in fpp_line */
EXTERN int RLENGTH;			/* regexp match length in fpp_line */
EXTERN int selected[MAXLEVEL];		/* for conditional branch flagging */
EXTERN char *TOKEN;			/* pointer to pp-token in fpp_line */

const char	*concat ARGS((const char *s_, const char *t_));
const char	*defined ARGS((void));
int		doarg ARGS((const char *s_));
void		dodef ARGS((const char *s_));
void		dodef2 ARGS((const char *thename_, const char *thevalue_,
			     int permanent_));
void		dofile ARGS((const char *filename_));
void		doundef ARGS((const char *s_));
char		*dtos ARGS((double d_));
void		error ARGS((const char *message_, int dump_lineno_));
const char	*eval ARGS((const char *s_));
char		*expand ARGS((const char *s_));
const char	*expr ARGS((void));
const char	*factor ARGS((void));
const char	*getdef ARGS((const char *s_));
int		getline ARGS((void));
const char	*getname ARGS((const char *s_, int start_));
const char	*identification ARGS((void));
void		init ARGS((void));
int		install ARGS((const char *thename_, const char *thevalue_));
int 		is_macro_line ARGS((void));
int 		is_pp_line ARGS((void));
int		lookup ARGS((const char *thename_));
void		macro_line ARGS((void));
int		main ARGS((int argc_, char *argv_[]));
int		match_expr ARGS((const char *s_));
int		name ARGS((const char *s_));
void		normal_line ARGS((void));
int		number ARGS((const char *s_));
const char	*power ARGS((void));
void		pp_line ARGS((void));
void		process ARGS((void));
void		quit ARGS((const char *message_, int dump_lineno_));
char		*Strdup ARGS((const char *s_));
int		stricmp ARGS((const char *s_, const char *t_));
int		strnicmp ARGS((const char *s_, const char *t_, size_t n_));
const char	*term ARGS((void));
void		tokenize ARGS((const char *s_));
char		*trim ARGS((char *s_));

#endif /* !defined(FPP_H) */
